fl

14 wconstant _cs         \ P20
15 wconstant _Di         \ P21  connect to MCP3204's Din
16 wconstant _Do         \ P22  connect to MCP3204's Dout
17 wconstant _clk        
18 wconstant _Xr         
19 wconstant _Xl         
1a wconstant _Yu         
1b wconstant _Yd         

wvariable x_max
wvariable x_min
wvariable y_max
wvariable y_min
wvariable init_x
wvariable init_y

1 _cs lshift constant _csm 
1 _Di lshift constant _dim
1 _Do lshift constant _dom
1 _clk lshift constant _clkm
1 _Xr lshift constant _xrm
1 _Xl lshift constant _xlm
1 _Yu lshift constant _yum
1 _Yd lshift constant _ydm

: _cs_out _cs pinout ;
: _di_out _Di pinout ;
: _do_in _Do pinin ;
: _clk_out _clk pinout ;
: _xr_out _Xr pinout ;
: _xl_out _Xl pinout ;
: _yu_out _Yu pinout ;
: _yd_out _Yd pinout ;

: _cs_l _csm _maskoutlo ;
: _cs_h _csm _maskouthi ;
: _di_l _dim _maskoutlo ;
: _di_h _dim _maskouthi ;
: _clk_l _clkm _maskoutlo ;
: _clk_h _clkm _maskouthi ;
\ : _xr_l _xrm _maskoutlo ;
: _xr_h _xrm _maskouthi ;
\ : _xl_l _xlm _maskoutlo ;
\ : _xl_h _xlm _maskouthi ;
\ : _yu_l _yum _maskoutlo ;
: _yu_h _yum _maskouthi ;
\ : _yd_l _ydm _maskoutlo ;
\ : _yd_h _ydm _maskouthi ;

: get_a/d
_cs_l
5 0 do dup 1 4 i - lshift and 0> if _di_h else _di_l then
       _clk_l _clk_h
    loop
    drop
_clk_l _clk_h
    
0
d 0 do _clk_l _clk_h
       ina COG@ _dom and 0> if 1+ then
       1 lshift   
    loop
    1 rshift
_cs_h
;

: get_pos
18 4 0 do dup pinin 1+ loop drop        \ set P24-P27 to input

_yu_out _yd_out _yu_h  
a 0 do 19 get_a/d loop        \ ch1 X-axis
9 0 do + loop a u/  \ dup .
_Yu pinin _Yd pinin

_xr_out _xl_out _xr_h 
a 0 do 18 get_a/d loop        \ ch0 Y-axis
9 0 do + loop a u/  \ dup .
_Xr pinin _Xl pinin       \ cr
;

: init_TS
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 
0 dup init_y W! init_x W!
64 delms
a 0 do get_pos dup init_y W@ > if 10 + init_y W! else drop then 
               dup init_x W@ > if 10 + init_x W! else drop then
       a delms
    loop
    
." init_y=" init_y W@ . ." init_x=" init_x W@ .  cr
;

: cal
begin
     get_pos  \ ." input=" dup . swap dup . swap  cr
     dup init_y W@ < if swap dup init_x W@ < if 2drop 0
                                             else swap 1
                                             then
                     else 1
                     then
     if  \ ." input=" dup . swap dup . swap  cr
     dup dup a u/ + y_max W! dup a u/ - y_min W!
     dup dup a u/ + x_max W! dup a u/ - x_min W!
     
  \   ." y="   y_max W@ .  y_min W@ . ."   x=" x_max W@ . x_min W@ . cr
        
     64 delms
 \    get_pos dup y_min W@ y_max W@ between if begin get_pos init_y W@ < if init_x W@ < if 1 else 0 then
 \                                                                       else drop 0
     get_pos dup y_min W@ y_max W@ between if begin get_pos init_y W@ < if init_x W@ < if 1 else 0 then
                                                                        else drop 0
                                                                        then
                                              until 1                                               
                                           else 2drop 0
                                           then
     else 0
     then                                            
   \  500 delms
until 
;






{
: AD_test
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

100 0 do 19 get_a/d    \ ch0
          . cr
          100 delms
          loop
; 
: get_TS
18 4 0 do dup pinin 1+ loop drop        \ set P24-P27 to input

_yu_out _yd_out _yu_h  
a 0 do 19 get_a/d loop        \ ch1 X-axis
9 0 do + loop a u/ .
_Yu pinin _Yd pinin

_xr_out _xl_out _xr_h 
a 0 do 18 get_a/d loop        \ ch0 Y-axis
9 0 do + loop a u/ .
_Xr pinin _Xl pinin
;

: TS_test
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

100 0 do get_TS cr 100 delms loop
;


: get_pos
18 4 0 do dup pinin 1+ loop drop        \ set P24-P27 to input

_yu_out _yd_out _yu_h  
a 0 do 19 get_a/d loop        \ ch1 X-axis
9 0 do + loop a u/  \ dup .
_Yu pinin _Yd pinin

_xr_out _xl_out _xr_h 
a 0 do 18 get_a/d loop        \ ch0 Y-axis
9 0 do + loop a u/  \ dup .
_Xr pinin _Xl pinin       \ cr
;

: TS
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

10 0 do
begin
     get_pos dup dup 5 u/ 1+ + y_max W! dup 5 u/ 1- - y_min W!
     dup dup 5 u/ 1+ + x_max W! dup 5 u/ 1- - x_min W!
     
     ." y="   y_max W@ .  y_min W@ . ."   x=" x_max W@ . x_min W@ . cr
        
     100 delms
     get_pos dup . dup y_min y_max between dup . if ." y_ng" 0 
                                     else swap dup . dup x_min x_max between if 2drop ." x_ng"  0    
                                                                       else swap 1
                                                                       then
                                   then     st?
until
cr ." result" . .  cr
loop
;

\ fl
: test
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

\ 100 delms get_pos a + init_y W! 10 + init_x W!
 
0 dup init_y W! init_x W!
64 delms
a 0 do get_pos dup init_y W@ > if 10 + init_y W! else drop then 
               dup init_x W@ > if 10 + init_x W! else drop then
       a delms
    loop
    
." init_y=" init_y W@ . ." init_x=" init_x W@ .  cr

10 0 do
begin
     get_pos  \ ." input=" dup . swap dup . swap  cr
     dup init_y W@ < if swap dup init_x W@ < if 2drop 0
                                             else swap 1
                                             then
                     else 1
                     then
     if  \ ." input=" dup . swap dup . swap  cr
     dup dup a u/ + y_max W! dup a u/ - y_min W!
     dup dup a u/ + x_max W! dup a u/ - x_min W!
     
  \   ." y="   y_max W@ .  y_min W@ . ."   x=" x_max W@ . x_min W@ . cr
        
     64 delms
 \    get_pos dup y_min W@ y_max W@ between if begin get_pos init_y W@ < if init_x W@ < if 1 else 0 then
 \                                                                       else drop 0
     get_pos dup y_min W@ y_max W@ between if begin get_pos init_y W@ < if init_x W@ < if 1 else 0 then
                                                                        else drop 0
                                                                        then
                                              until 1                                               
                                           else 2drop 0
                                           then
     else 0
     then                                            
   \  500 delms
until 

." result"  . .  cr
loop                                                
;







: test
1 swap lshift dup . dup dira COG! 
a 0 do dup outa COG! 100 delms 0 outa COG! 100 delms loop drop
\ _xr_out  _xl_out
\ a 0 do _xr_h _xl_h 100 delms _xr_l _xl_l 100 delms  loop

;

: test1
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

100 0 do
18 4 0 do dup pinin 1+ loop drop

_xr_out _xl_out _xr_h 
a 0 do 18 get_a/d loop        \ ch0 Y-axis
9 0 do + loop a u/ .
_Xr pinin _Xl pinin
100 delms
cr
loop
;

: testy
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 
18 4 0 do dup pinin 1+ loop drop
_xr_out _xl_out _xr_h  
30 0 do 18 get_a/d    \ ch0
          . cr
          100 delms
          loop
;

: testx
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 
18 4 0 do dup pinin 1+ loop drop
_yu_out _yd_out _yu_h 
30 0 do 19 get_a/d    \ ch1
          . cr
          100 delms
          loop
;


: t
_xl_out  dira COG@ . cr
10 0 do _xl_h outa COG@ . cr 100 delms _xl_l outa COG@ . cr 100 delms loop
;

: tt
_xr_out
10 0 do _xr_h 100 delms _xr_l 100 delms loop
;
}